/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "PUNKT Zentrum = new PUNKT();\nZentrum.y = 3;\nKREIS Rund = new KREIS();\nRund.radius = 5;\nRund.mittelpunkt = Zentrum;\nRund.mittelpunkt.y = 4;\nif (Rund.mittelpunkt == Zentrum) {\n    Zentrum.x = 2;\n}\nPUNKT Ursprung = new PUNKT();\nRund.mittelpunkt = new PUNKT();\nif (Rund.mittelpunkt == Ursprung) {\n    Ursprung = 0;\n}\nRund.mittelpunkt.x = Zentrum.y;\nRund.mittelpunkt.y = 3;\nif (Ursprung == Rund) {\n    Ursprung = null;\n}",
	"classes": [
		{
			"className": "PUNKT",
			"atts": [
				{
					"key": "x",
					"type": "int",
					"value": 0
				},
				{
					"key": "y",
					"type": "int",
					"value": 0
				}
			]
		},
		{
			"className": "KREIS",
			"atts": [
				{
					"key": "mittelpunkt",
					"type": "PUNKT",
					"ref": null
				},
				{
					"key": "radius",
					"type": "int",
					"value": 0
				}
			]
		}
	],
	"notSelectable": [
		8,
		13,
		18
	],
	"steps": [
		{
			"task": "Führe den Code aus, indem du immer die Auswirkungen der hervorgehobenen Zeile in der Speichertabelle einträgst und die nächste auszuführende Codezeile auswählst.",
			"line": 0,
			"vars": [],
			"allowArrays": false,
			"enableOverload": false,
			"autoremoveGarbage": false,
			"enableTextOut": false
		},
		{
			"line": 1,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 2,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					}
				],
				"scopes": []
			}
		},
		{
			"line": 3,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": null
							},
							{
								"key": "radius",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					}
				],
				"scopes": []
			}
		},
		{
			"line": 4,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": null
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					}
				],
				"scopes": []
			}
		},
		{
			"line": 5,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 0
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					}
				],
				"scopes": []
			}
		},
		{
			"line": 6,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 0
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					}
				],
				"scopes": []
			}
		},
		{
			"line": 7,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 0
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					}
				],
				"scopes": []
			}
		},
		{
			"line": 9,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 0
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					}
				],
				"scopes": []
			}
		},
		{
			"line": 10,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 0
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 16
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					},
					{
						"key": "Ursprung",
						"type": "PUNKT",
						"ref": 16
					}
				],
				"scopes": []
			}
		},
		{
			"line": 11,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 24
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 16
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 24
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					},
					{
						"key": "Ursprung",
						"type": "PUNKT",
						"ref": 16
					}
				],
				"scopes": []
			}
		},
		{
			"line": 14,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 24
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 16
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 24
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					},
					{
						"key": "Ursprung",
						"type": "PUNKT",
						"ref": 16
					}
				],
				"scopes": []
			}
		},
		{
			"line": 15,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 24
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 16
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 4
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 24
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					},
					{
						"key": "Ursprung",
						"type": "PUNKT",
						"ref": 16
					}
				],
				"scopes": []
			}
		},
		{
			"line": 16,
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 24
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 16
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 4
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 24
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					},
					{
						"key": "Ursprung",
						"type": "PUNKT",
						"ref": 16
					}
				],
				"scopes": []
			}
		},
		{
			"line": "end",
			"vars": {
				"instances": [
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 2
							},
							{
								"key": "y",
								"type": "int",
								"value": 4
							}
						],
						"pointer": 0
					},
					{
						"instance": "object",
						"className": "KREIS",
						"atts": [
							{
								"key": "mittelpunkt",
								"type": "PUNKT",
								"ref": 24
							},
							{
								"key": "radius",
								"type": "int",
								"value": 5
							}
						],
						"pointer": 8
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 0
							},
							{
								"key": "y",
								"type": "int",
								"value": 0
							}
						],
						"pointer": 16
					},
					{
						"instance": "object",
						"className": "PUNKT",
						"atts": [
							{
								"key": "x",
								"type": "int",
								"value": 4
							},
							{
								"key": "y",
								"type": "int",
								"value": 3
							}
						],
						"pointer": 24
					}
				],
				"vars": [
					{
						"key": "Zentrum",
						"type": "PUNKT",
						"ref": 0
					},
					{
						"key": "Rund",
						"type": "KREIS",
						"ref": 8
					},
					{
						"key": "Ursprung",
						"type": "PUNKT",
						"ref": 16
					}
				],
				"scopes": []
			}
		}
	]
};